#ifndef LIBWCCL_PARSER_PARSINGSCOPE_H
#define LIBWCCL_PARSER_PARSINGSCOPE_H

#include <libwccl/variables.h>
#include <libwccl/lexicon/lexicons.h>

namespace Wccl {

class ParsingScope
{
public:
	ParsingScope(const Corpus2::Tagset& tagset)
		: tagset_(tagset),
		  variables_(),
		  lexicons_(new Lexicons())
	{
	}

	const Corpus2::Tagset& tagset() {
		return tagset_;
	}

	Variables& variables() {
		return variables_;
	}

	boost::shared_ptr<Lexicons> lexicons_ptr() {
		return lexicons_;
	}

	Lexicons& lexicons() {
		return *lexicons_;
	}

private:
	const Corpus2::Tagset& tagset_;
	Variables variables_;
	boost::shared_ptr<Lexicons> lexicons_;
};

} /* end ns Wccl */

#endif // LIBWCCL_PARSER_PARSINGSCOPE_H
